//
// DoDs Speed Bonus Round
// -----------------------------
// Based form <eVa>Dog's Dog Bonus Round
// http://www.dodsplugins.com
//
// For DoD:Source
// This plugin beacon the losing Team and give speed to the Winners
// Just to have a funny moment at round end
// -----------------------------

#include <sourcemod>
#include <sdktools>

#define SPEC 1
#define ALLIES 2
#define AXIS 3

#define PLUGIN_VERSION "2.2"
#define BEACON_DELAY 1.5

new g_beamSprite
new g_haloSprite

new bool:gB_Enabled[MAXPLAYERS+1];

new String:WpnMelee[4][] = { "", "", "weapon_amerknife", "weapon_spade" }

new Handle:cvar_kicknodl = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = "DoD chicken Bonus Round",
	author = "<eVa>Dog, vintage, modif Micmacx",
	description = "Beacon and skin the loosing Team, give speed to the Winners",
	version = PLUGIN_VERSION,
	url = "http://www.dodsplugins.com"
}

public OnPluginStart()
{
	CheckGame()

	HookEvent("dod_round_start", Hook_RoundStart, EventHookMode_Post)
	HookEvent("dod_round_win", Hook_RoundWin, EventHookMode_Post)
	CreateConVar("dod_chicken_bonusround_version", PLUGIN_VERSION, "DoD chicken Bonus Round Version (DO NOT CHANGE!)", FCVAR_DONTRECORD | FCVAR_SPONLY | FCVAR_REPLICATED | FCVAR_NOTIFY)
	cvar_kicknodl = CreateConVar("dod_chicken_bonusround_kicknodl", "1", "Enabled/Disabled kicking players with DL-filter, 0 = off/1 = on", _, true, 0.0, true, 1.0)
	AutoExecConfig(true, "dod_chicken_bonusround", "dod_chicken_bonusround")
	CreateTimer(BEACON_DELAY, BeaconTimer, 0, TIMER_REPEAT)
}

public OnMapStart()
{
	AddFileToDownloadsTable("sound/dod_chicken_bonusround/fais_la_poule.mp3")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/body.vmt")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/body.vtf")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/eye.vmt")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/eye.vtf")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/face.vmt")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/face.vtf")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/face_n.vtf")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/hand.vmt")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/hand.vtf")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/hand_n.vtf")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/head.vmt")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/head.vtf")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/head_n.vtf")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/legs.vmt")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/legs.vtf")
	AddFileToDownloadsTable("materials/models/player/micx_chicken/legs_n.vtf")
	AddFileToDownloadsTable("models/player/micx_chicken/cock.dx80.vtx")
	AddFileToDownloadsTable("models/player/micx_chicken/cock.dx90.vtx")
	AddFileToDownloadsTable("models/player/micx_chicken/cock.mdl")
	AddFileToDownloadsTable("models/player/micx_chicken/cock.phy")
	AddFileToDownloadsTable("models/player/micx_chicken/cock.sw.vtx")
	AddFileToDownloadsTable("models/player/micx_chicken/cock.vvd")
	PrecacheModel("models/player/micx_chicken/cock.mdl")
	PrecacheSound("buttons/button17.wav",true)
	PrecacheSound("dod_chicken_bonusround/fais_la_poule.mp3", true)
	g_beamSprite = PrecacheModel("materials/sprites/laser.vmt")
	g_haloSprite = PrecacheModel("materials/sprites/halo01.vmt")
}

public OnClientAuthorized(client, const String:auth[])
{
	if(GetConVarInt(cvar_kicknodl) == 1)
	{
		QueryClientConVar(client, "cl_downloadfilter", ConVarQueryFinished:dlfilter);
	}
}

public dlfilter(QueryCookie:cookie, client, ConVarQueryResult:result, const String:cvarName1[], const String:cvarValue1[])
{
	if(IsClientConnected(client))
	{
		if(strcmp(cvarValue1, "none", true) == 0)
		{
			KickClient(client, "Please enable SkinDownload and reconnect!");
		}
	}
}

public void OnClientPutInServer(int client)
{
	gB_Enabled[client] = false;
}

public Hook_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	for(new x = 1; x <= MaxClients; x++)
	{
		if(IsClientConnected(x) && IsClientInGame(x) && IsPlayerAlive(x))
		{
			gB_Enabled[x] = false;
		}
	}
}


public Hook_RoundWin(Handle:event, const String:name[], bool:dontBroadcast)
{
	EmitSoundToAll("dod_chicken_bonusround/fais_la_poule.mp3")
	new winnerTeam = GetEventInt(event, "team")

	for (new x = 1; x <= MaxClients; x++)
	{
		if(IsClientConnected(x) && IsClientInGame(x) & IsPlayerAlive(x))
		{
			if(GetClientTeam(x) == winnerTeam)
			{
				StripWeapons(x)
				SetEntPropFloat(x, Prop_Data, "m_flLaggedMovementValue", 1.5)
				SetEntProp(x, Prop_Data, "m_takedamage", 0, 1)
				GivePlayerItem(x,WpnMelee[winnerTeam])

				continue
			}
			else
			{
				StripWeapons(x)		
				SetEntityModel(x,"models/player/micx_chicken/cock.mdl")
				GivePlayerItem(x,WpnMelee[winnerTeam])
				PrintCenterText(x, "DANGER! Run! Run! Run!")
				gB_Enabled[x] = !gB_Enabled[x];
			}
		}
	}
}

public Action:BeaconTimer(Handle:timer)
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if(gB_Enabled[client] && IsClientConnected(client) && IsClientInGame(client) && IsPlayerAlive(client))
		{
			BeamRing(client)
			new Float:vecPos[3]
			GetClientAbsOrigin(client, vecPos)
			EmitSoundToAll("buttons/button17.wav", client, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, 1.0, SNDPITCH_NORMAL, -1, vecPos, NULL_VECTOR, true, 0.0)
		}
	}

	return Plugin_Continue;
}


CheckGame()
{
	new String:strGame[10]
	GetGameFolderName(strGame, sizeof(strGame))

	if(StrEqual(strGame, "dod"))
	{
		PrintToServer("[dod_chicken_bonusround] Version %s dod_chicken_bonusround loaded.", PLUGIN_VERSION)
	}
	else
	{
		SetFailState("[dod_chicken_bonusround] This plugin is made for DOD:S! Disabled.")
	}
}

BeamRing(client)
{
	new color[] = {248, 96, 244, 255}

	new Float:vec[3]
	GetClientAbsOrigin(client, vec)

	vec[2] += 5;

	TE_Start("BeamRingPoint")
	TE_WriteVector("m_vecCenter", vec)
	TE_WriteFloat("m_flStartRadius", 20.0)
	TE_WriteFloat("m_flEndRadius", 440.0)
	TE_WriteNum("m_nModelIndex", g_beamSprite)
	TE_WriteNum("m_nHaloIndex", g_haloSprite)
	TE_WriteNum("m_nStartFrame", 0)
	TE_WriteNum("m_nFrameRate", 0)
	TE_WriteFloat("m_fLife", 1.0)
	TE_WriteFloat("m_fWidth", 6.0)
	TE_WriteFloat("m_fEndWidth", 6.0)
	TE_WriteFloat("m_fAmplitude", 0.0)
	TE_WriteNum("r", color[0])
	TE_WriteNum("g", color[1])
	TE_WriteNum("b", color[2])
	TE_WriteNum("a", color[3])
	TE_WriteNum("m_nSpeed", 50)
	TE_WriteNum("m_nFlags", 0)
	TE_WriteNum("m_nFadeLength", 0)
	TE_SendToAll()
}

public Action:StripWeapons(x)
{
	for(new i = 0; i < 4; i++)
	{
		new weapon = GetPlayerWeaponSlot(x, i)
		if(weapon != -1)
		{
			RemovePlayerItem(x, weapon)
			RemoveEdict(weapon)
		}
	}
}